// #pragma GCC optimize("O3")

#include <bits/stdc++.h>
#include <climits>

using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"
#define chmyax(a, b) a = max(a, b)
#define chmyin(a, b) a = min(a, b)

struct Verticy {
  ll v;
  ll l;
  ll r;
};

struct SegmentTreeMax {
  vector<Verticy> vertices;
  ll N;
  ll DEF;
  ll addvert() {
    vertices.push_back({DEF, -1, -1});
    return vertices.size() - 1;
  }
  void build(ll n, ll ini) {
    N = n;
    DEF = ini;
    addvert();
  }
  ll get(ll ql, ll qr) { return _get(0, 0, N - 1, ql, qr); }
  ll _get(ll v, ll l, ll r, ll ql, ll qr) {
    // cout << v << " " << l << " " << r << " " << ql << " " << qr << endl;
    if (ql > qr)
      return DEF;
    if (l == ql && r == qr) {
      // cout << vertices[v].v << endl;
      return vertices[v].v;
    }
    ll m = (l + r) / 2;
    return max(
        (vertices[v].l == -1 ? DEF : _get(vertices[v].l, l, m, ql, min(qr, m))),
        (vertices[v].r == -1
             ? DEF
             : _get(vertices[v].r, m + 1, r, max(ql, m + 1), qr)));
  }
  void update(ll ind, ll val) { _update(0, 0, N - 1, ind, val); }
  void _update(ll v, ll l, ll r, ll ind, ll val) {
    if (l == r) {
      vertices[v].v = val;
      return;
    }
    ll m = (l + r) / 2;
    if (ind <= m) {
      if (vertices[v].l == -1) {
        vertices[v].l = addvert();
      }
      _update(vertices[v].l, l, m, ind, val);
    } else {
      if (vertices[v].r == -1) {
        vertices[v].r = addvert();
      }
      _update(vertices[v].r, m + 1, r, ind, val);
    }
    vertices[v].v =
        max((vertices[v].l == -1 ? DEF : vertices[vertices[v].l].v),
            (vertices[v].r == -1 ? DEF : vertices[vertices[v].r].v));
  }
};
const ll MX = 1e17;

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  freopen("in", "r", stdin);
  ll a, b, c, d, e, f, g, n, m, k;
  char ch;
  ll q, x;
  cin >> n >> q;
  vector<ll> arr(n);
  for (ll i = 0; i < n; i++) {
    cin >> arr[i];
  }
  while (q--) {
    cin >> a >> b >> x;
    --a;
    --b;
    SegmentTreeMax st_min;
    SegmentTreeMax st_max;
    st_min.build(2 * MX + 5, -1e9);
    st_max.build(2 * MX + 5, -1e9);
    for (ll i = a; i <= b; i++) {
      arr[i] += x;
    }
    ll ans = 0;
    st_min.update(arr[0] + MX, arr[0]);
    st_max.update(arr[0] + MX, -arr[0]);
    for (ll i = 0; i < n; i++) {
      // assume this is min
      ll score_min = st_min.get(arr[i] + MX, 2 * MX) - arr[i];
      // assume this is max
      ll score_max = arr[i] + st_max.get(MX, MX + arr[i]);
      if (i < n - 1) {
        st_min.update(arr[i + 1] + MX, score_max + arr[i + 1]);
        st_max.update(arr[i + 1] + MX, score_min - arr[i + 1]);
      }
      chmyax(ans, score_min);
      chmyax(ans, score_max);
    }
    cout << ans << nl;
  }
}
