#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;
using ld = long double;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vector<vector<pair<int, int>>> max_rectangle(n + 1, vector<pair<int, int>>(m + 1, { 0, 0 }));

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            char tile;
            cin >> tile;

            if (tile == '*') {
                auto prev_row = max_rectangle[i - 1][j];
                auto prev_col = max_rectangle[i][j - 1];

                max_rectangle[i][j] = { prev_col.first + 1, prev_row.second + 1 };
            }
        }
    }
    
    int rects = 0;

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (max_rectangle[i][j].first == 1 && max_rectangle[i][j].second == 1) {
                rects += 1;
            }
        }
    }

    cout << rects << "\n";

    return 0;
}
