#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;
using ld = long double;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    ll k;

    cin >> n >> k;

    vector<vector<int>> blame_matrix(n, vector<int>(n));

    for (auto& row : blame_matrix) {
        for (auto& cell : row) {
            cin >> cell;
            cell -= 1;
        }
    }

    vector<pair<int, int>> path{};
    map<pair<int, int>, int> seen{};

    int parent = 0;
    int current = 1;
    ll loop_start_index = 0;

    while (true) {
        seen[{ parent, current }] = path.size();
        path.push_back({ parent, current });

        int temp = current;
        current = blame_matrix[current][parent];
        parent = temp;

        if (seen.find({ parent, current }) != seen.end()) {
            loop_start_index = seen[{ parent, current }];
            break;
        }
    }

    ll loop_size = path.size() - loop_start_index;

    if (k <= loop_start_index) {
        cout << path[k - 1].first + 1 << "\n";
    } else {
        cout << path[loop_start_index + (k - loop_start_index - 1) % loop_size].first + 1 << "\n";
    }

    return 0;
}
