#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;
using ld = long double;

const int infinity = std::numeric_limits<int>::max() / 2;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vector<int> calendar(n + 1);
    calendar[0] = (1 << m) - 1;

    for (int i = 1; i <= n; i++) {
        int mask = 0;

        for (int j = 0; j < m; j++) {
            char tile;
            cin >> tile;

            if (tile == '.') {
                mask |= (1 << j);
            }
        }

        calendar[i] = mask;
    }

    vector<int> masks{};
    vector<int> mask_horizontal_segments{};

    for (int i = 0; i < (1 << m); i++) {
        bool bad = false;
        int horizontal_segments = 0;

        for (int j = 0; j < m; j++) {
            bool prev0 = j == 0 || ((i >> (j - 1)) & 1) == 0;
            bool next0 = j == m - 1 || ((i >> (j + 1)) & 1) == 0;

            if (((i >> j) & 1) == 1) {
                if (prev0 && next0) {
                    bad = true;
                    break;
                }
            } else if (!prev0) {
                horizontal_segments += 1;
            }
        }

        if (((i >> (m - 1)) & 1) == 1) {
            horizontal_segments += 1;
        }

        if (!bad) {
            masks.push_back(i);
            mask_horizontal_segments.push_back(horizontal_segments);
        }
    }

    // cout << masks.size() << "\n";

    auto dp { vector(n + 1, vector<int>(masks.size())) };

    for (int i = 1; i <= n; i++) {
        for (int mask_index = 0; mask_index < masks.size(); mask_index++) {
            dp[i][mask_index] = infinity;

            int mask = masks[mask_index];
            int horizontal_segments = mask_horizontal_segments[mask_index];

            if (((~calendar[i]) | mask) != (~calendar[i])) {
                continue;
            } 

            for (int prev_mask_index = 0; prev_mask_index < masks.size(); prev_mask_index++) {
                int prev_mask = masks[prev_mask_index];
                int prev_available_vertical = ~(prev_mask | calendar[i - 1]);
                int prev_not_available_vertical = prev_mask | calendar[i - 1];
                int curr_needs_vertical = (~(mask | calendar[i])) & ((1 << m) - 1);

                dp[i][mask_index] = min(
                    dp[i][mask_index],
                    horizontal_segments
                        + dp[i - 1][prev_mask_index]
                        + __builtin_popcount(prev_not_available_vertical & curr_needs_vertical)
                );
            }
        }
    }

    int result = infinity;

    for (int i = 0; i < masks.size(); i++) {
        result = min(result, dp[n][i]);
    }

    cout << result << "\n";

    return 0;
}
