#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;
using ld = long double;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    vector<ll> array(n);

    for (auto& element : array) {
        cin >> element;
    }

    auto get_max_cost = [&]() {
        vector<int> monotone_until(n);
        monotone_until[0] = 0;
        
        vector<int> interesting_points{};

        for (int i = 0; i < n - 1;) {
            int old_i = i;

            if (array[i] >= array[i + 1]) {
                while (i < n - 1 && array[i] >= array[i + 1]) {
                    i++;
                    monotone_until[i] = old_i;
                }
            } else if (array[i] < array[i + 1]) {
                while (i < n - 1 && array[i] < array[i + 1]) {
                    i++;
                    monotone_until[i] = old_i;
                }
            }

            interesting_points.push_back(i - 1);
            interesting_points.push_back(i);
        }

        vector<ll> dp(n);
        dp[0] = 0;

        for (int i : interesting_points) {
            dp[i] = max(
                abs(array[i] - array[monotone_until[i]]) + (monotone_until[i] > 0 ? dp[monotone_until[i] - 1] : 0),
                abs(array[i] - array[monotone_until[i] + 1]) + dp[monotone_until[i]]
            );
        }

        return dp[n - 1];
    };

    for (int i = 0; i < q; i++) {
        int l, r;
        ll x;

        cin >> l >> r >> x;

        for (int j = l - 1; j < r; j++) {
            array[j] += x;
        }

        cout << get_max_cost() << "\n";
    }

    return 0;
}
