#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;
using ld = long double;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    vector<ll> array(n);

    for (auto& element : array) {
        cin >> element;
    }

    // vector<int> monotone_until(n);
    set<int> interesting_points{};

    for (int i = 0; i < n - 1;) {
        int old_i = i;

        if (array[i] >= array[i + 1]) {
            while (i < n - 1 && array[i] >= array[i + 1]) {
                i++;
                // monotone_until(i) = old_i;
            }
        } else if (array[i] < array[i + 1]) {
            while (i < n - 1 && array[i] < array[i + 1]) {
                i++;
                // monotone_until(i) = old_i;
            }
        }

        interesting_points.insert(i);
    }

    auto monotone_until = [&](int i) {
        auto iter = interesting_points.lower_bound(i);

        return iter == interesting_points.begin() ? 0 : *prev(iter);
    };

    auto get_max_cost = [&]() {
        vector<ll> dp(n);
        dp[0] = 0;

        for (int i : interesting_points) {
            dp[i] = max(
                abs(array[i] - array[monotone_until(i)]) + (monotone_until(i) > 0 ? dp[monotone_until(i) - 1] : 0),
                abs(array[i] - array[monotone_until(i) + 1]) + dp[monotone_until(i)]
            );

            if (i - 1 > 0) {
                dp[i - 1] = max(
                    abs(array[i - 1] - array[monotone_until(i - 1)]) + (monotone_until(i - 1) > 0 ? dp[monotone_until(i - 1) - 1] : 0),
                    abs(array[i - 1] - array[monotone_until(i - 1) + 1]) + dp[monotone_until(i - 1)]
                );
            }
        }

        return dp[n - 1];
    };

    for (int i = 0; i < q; i++) {
        int l, r;
        ll x;

        cin >> l >> r >> x;

        l -= 1;

        for (int j = l; j < r; j++) {
            array[j] += x;
        }

        // if (l > 0) {
        //     if (array[l] > array[l - 1] && array[l] + x <= array[l - 1]) {
        //         int int_point = *interesting_points.lower_bound(l);

        //         if (int_point < r) {
        //             if (array[int_point] > array[monotone_until[int_point]]) {
        //                 monotone_until[int_point] = l;
        //                 monotone_until[l] = l - 1;
        //                 interesting_points.insert(l - 1);
        //                 interesting_points.insert(l);
        //             } else {
        //                 monotone_until[int]
        //             }
        //         }

        //         if (int_point <= r) {
        //             monotone_until[int_point - 1] = l;
        //         }

        //         interesting_points.insert(l);
        //     } else if (array[l] <= array[l - 1] && array[l] + x > array[l - 1]) {

        //     }
        // }

        cout << get_max_cost() << "\n";
    }

    return 0;
}
