#include <bits/stdc++.h>
using namespace std;

const int DIM = 100;

struct Cord{
    int x, y;
};

int n, m;
bool char_map[DIM][DIM];
bool used[DIM][DIM];

int d_x[4] {1, -1,  0,  0};
int d_y[4] {0,  0,  1, -1};

void input_map(){
    char symb;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j){
            cin >> symb;
            char_map[i][j] = (symb == '*');
        }
}

bool check(int x, int y){
    return (x >= 0 && x < n) && (y >= 0 && y < m) && (!used[x][y]) && (char_map[x][y]);
}

void bfs(Cord start){
    queue<Cord> Q;
    Cord curr; int x, y;

    used[start.x][start.y] = true;
    Q.push(start);
    while (!Q.empty()){
        curr = Q.front(); Q.pop();
        for (int k = 0; k < 4; ++k){
            x = curr.x + d_x[k];
            y = curr.y + d_y[k];

            if (check(x, y)){
                used[x][y] = true;
                Q.push({x, y});
            }
        }
    } 
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> m; input_map();

    int cnt_rects = 0;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            if (check(i,j)){
                ++cnt_rects;
                bfs({i,j});
            }

    cout << cnt_rects << '\n';

    return 0;
}
