#include <bits/stdc++.h>
using namespace std;

const int N_DIM = 1000, M_DIM = 10;
struct Cord{
    int x, y;
};

int n, m;
bool char_map[N_DIM][M_DIM];
bool used[N_DIM][M_DIM];

void input_map(){
    char c;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j){
            cin >> c;
            char_map[i][j] = (c == '#');
        }
}

bool check(int x, int y){
    return (x >= 0 && x < n) && (y >= 0 && y < m) && (!used[x][y]) && (char_map[x][y]);
}

void place_horizontal(Cord start){
    used[start.x][start.y] = true;
    int left_border = start.y-1, right_border = start.y+1;
    while (check(start.x, left_border))
        used[start.x][left_border--] = true;
    while (check(start.x, right_border))
        used[start.x][right_border++] = true;
}
void place_vertical(Cord start){
    used[start.x][start.y] = true;
    int upper_border = start.x-1, lower_border = start.x+1;
    while (check(upper_border, start.y))
        used[upper_border--][start.y] = true;
    while (check(lower_border, start.y))
        used[lower_border++][start.y] = true;
}

const int d_x[4] = { -1,  0,  1,  0};
const int d_y[4] = {  0,  1,  0, -1};

bool is_street(Cord cell){
    return check(cell.x, cell.y) && ((check(cell.x, cell.y + 1) && check(cell.x, cell.y - 1)) || (check(cell.x + 1, cell.y) && check(cell.x - 1, cell.y)));
}

bool is_stop(Cord cell){
    if (!check(cell.x, cell.y))
        return false;

    int q_not_used_neigh = 0;
    for (int i = 0; i < 4; ++i)
        q_not_used_neigh += check(cell.x + d_x[i], cell.y + d_y[i]);
    return q_not_used_neigh < 2;
}

bool is_big_angle(Cord cell){
    if (!check(cell.x, cell.y))
        return false;
        
    for (int k = 0; k < 4; ++k){
        if ((is_street({cell.x + d_x[k], cell.y + d_y[k]}) || is_stop({cell.x + d_x[k], cell.y + d_y[k]})) &&
            (is_street({cell.x + d_x[(k+1)%4], cell.y + d_y[(k+1)%4]}) || is_stop({cell.x + d_x[(k+1)%4], cell.y + d_y[(k+1)%4]})))
            return true;
    }

    return false;
}

bool is_square(Cord cell){
    return check(cell.x, cell.y) && check(cell.x + 1, cell.y) && check(cell.x, cell.y + 1) && check(cell.x + 1, cell.y + 1);
}

void place_square(Cord cell){
    used[cell.x][cell.y] = true;
    used[cell.x+1][cell.y] = true;
    used[cell.x][cell.y+1] = true;
    used[cell.x+1][cell.y+1] = true;
}

void output_map(){
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j)
            cout << (check(i, j) ? '#' : '.');
        cout << '\n';
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> m; input_map();

    int res = 0;

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            if (is_big_angle({i, j})){
                place_horizontal({i, j});
                ++res;
            }
    
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            if (is_stop({i, j})){
                if (check(i-1, j) || check(i+1, j))
                    place_vertical({i, j});
                else
                    place_horizontal({i, j});
                ++res;
            }
    
    for (int i = 0; i < n-1; ++i)
        for (int j = 0; j < m-1; ++j)
            if (is_square({i, j})){
                place_square({i, j});
                res += 2;
            }

    cout << res << '\n';

    return 0;
}
