#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>

using namespace std;

#define LF '\n';
typedef int lli;
typedef long double ld;

vector<lli> v;

const lli INF = 1e9 + 2;

struct SIGMAK_TABLE
{
    const lli K = 25;
    vector<vector<lli>> minn;
    vector<vector<lli>> maxx;
    vector<lli> t;
    void build(lli n) {
        t.clear();
        t.resize(n + 1);
        for (int i = 2; i <= n; i++)t[i] = t[i / 2] + 1;
        minn.clear();
        maxx.clear();
        minn.resize(n + 1);
        maxx.resize(n + 1);
        for (int i = 1; i <= n; i++) {
            minn[i].resize(K, INF);
            maxx[i].resize(K, -INF);
            minn[i][0] = v[i];
            maxx[i][0] = v[i];
        }
        for (int b = 1; b < K; b++) {
            for (int i = 1; i <= n; i++) {
                lli to = min(n, (lli)i + (1 << (b - 1)));
                minn[i][b] = min(minn[i][b - 1], minn[to][b - 1]);
                maxx[i][b] = max(maxx[i][b - 1], maxx[to][b - 1]);
            }
        }
    }

    lli get_min(lli l, lli r) {
        lli d = (r - l + 1);
        return min(minn[l][t[d]], minn[r - (1<<t[d])+1][t[d]]);
    }
    lli get_max(lli l, lli r) {
        lli d = (r - l + 1);
        return max(maxx[l][t[d]], maxx[r - (1 << t[d]) + 1][t[d]]);
    }
}st;


vector<long long> dp;
void upd(lli i, lli j)
{
    if (j > i)return;
    long long minn = st.get_min(j, i);
    long long maxx = st.get_max(j, i);
    dp[i] = max(dp[i], dp[j - 1] + maxx - minn);

}

long long func(lli n) {
    dp.clear();
    dp.resize(n + 1);
    lli p1 = 1, p2 = 1;
    for (int i = 1; i <= n; i++) {
        upd(i, p1);
        upd(i, p2);
        upd(i, p1+1);
        upd(i, p2+1);
        if (v[i] < v[i - 1])p1 = i;
        if (v[i] > v[i - 1])p2 = i;
    }
    return dp[n];
}

void solve()
{
    lli n, q;
    cin >> n >> q;
    v.resize(n + 1);
    for (int i = 1; i <= n; i++)cin >> v[i];
    for (int i = 1; i <= q; i++) {
        lli l, r, x;
        cin >> l >> r >> x;
        for (int j = l; j <= r; j++)v[j] += x;
        st.build(n);
        lli ans = func(n);
        cout << ans << LF;
    }

}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 


    solve();
}

