#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>

using namespace std;

#define LF '\n';
typedef long long lli;
typedef long double ld;

vector<lli> v;
const lli N = 3e5;
const lli INF = 1e18;
struct fenwick
{
    vector<lli> f;
    
    void init() {
        f.resize(N+1,0);
    }

    void add(lli ind, lli val) {
        for (int i = ind; i < N; i += i & -i)f[i] += val;
    }

    void add_range(lli l, lli r, lli val) {
        add(l, val);
        add(r + 1, -val);
    }

    lli get(lli ind) {
        lli res = 0;
        for (int i = ind; i > 0; i -= i & -i)res += f[i];
        return res;
    }
}sf;


struct SUPER_SIGMAK_TREE
{
    struct node
    {
        lli x[2][2];
    };

    vector<node> t;
    lli n;

    lli val(lli ind) {
        return v[ind] + sf.get(ind);
    }

    node merge(node n1, node n2, lli l, lli m1, lli m2, lli r) {
        lli val1 = val(m1);
        lli val2 = val(m2);
        if (l == m1 && r == m2) {
            node res;
            res.x[0][0] = 0;
            res.x[0][1] = 0;
            res.x[1][0] = 0;
            res.x[1][1] = abs(val1 - val2);
            return res;
        }
     /*   if (l == m1) {
            node res=n2;
            res.x[1][0] = max(res.x[1][0], n2.x[0][0] + abs(val1-val2));
            res.x[1][1] = max(res.x[1][1], n2.x[0][1] + abs(val1-val2));
            return res;
        }
        if (r == m2) {
            node res = n1;
            res.x[0][1] = max(res.x[0][1], n1.x[0][0] + abs(val1 - val2));
            res.x[1][1] = max(res.x[1][1], n1.x[1][0] + abs(val1 - val2));
            return res;
        }*/
        lli b1 = 0, b2 = 0;
        node res;
        if (val1 > val2) {
            if (m1 != 1 && val(m1 - 1) >= val1)b1 = 1;
            if (m2 != n && val(m2 + 1) <= val2)b2 = 1;
        }
        else {
            if (m1 != 1 && val(m1 - 1) <= val1)b1 = 1;
            if (m2 != n && val(m2 + 1) >= val2)b2 = 1;
        }
        for (int c1 = 0; c1 <= 1; c1++) {
            for (int c2 = 0; c2 <= 1; c2++) {
                res.x[c1][c2] = max(n1.x[c1][1] + n2.x[1][c2], n1.x[c1][b1] + n2.x[b2][c2] + abs(val1-val2));
            }
        }
        return res;
    }

    void build(lli a, lli l, lli r) {
        if (l == r) {
            t[a].x[0][0]=0;
            t[a].x[0][1]=0;
            t[a].x[1][0]=0;
            t[a].x[1][1]=0;
            return;
        }
        lli m = (l + r) >> 1;
        build(a * 2 + 1, l, m);
        build(a * 2 + 2, m+1, r);
        t[a] = merge(t[a * 2 + 1], t[a * 2 + 2], l, m, m + 1, r);
    }

    void init(lli nn) {
        n = nn;
        t.resize(4 * n);
        build(0, 1, n);
    }

    void upd(lli a, lli tl, lli tr, lli l, lli r) {
        if (tl > r || tr < l)return;
        if (tl >= l && tr <= r)return;
        lli tm = (tl + tr) >> 1;
        upd(a * 2 + 1, tl, tm, l, r);
        upd(a * 2 + 2, tm+1, tr, l, r);
        t[a] = merge(t[a * 2 + 1], t[a * 2 + 2], tl, tm, tm + 1, tr);
    }

    void update(lli l, lli r, lli val) {
        sf.add_range(l, r, val);
        upd(0, 1, n, l, r);
    }
}st;

void solve()
{
    lli n, q;
    cin >> n >> q;
    v.clear();
    v.resize(n + 1);
    for (int i = 1; i <= n; i++)cin >> v[i];
    sf.init();
    st.init(n);
  //  cout << st.t[0].x[1][1] << LF;
//    return;
    for (int i = 1; i <= q; i++) {
        lli l, r, val;
        cin >> l >> r >> val;
        st.update(l, r, val);
        cout << st.t[0].x[1][1] << LF;
    }

}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 

    solve();
}

